controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use app\models\Ciclista;
use app\models\lleva;
use app\models\puerto;
use yii\data\SqlDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    public function actionConsulta1(){
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT edad FROM ciclista',
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['edad'],
            "titulo"=> "Consulta 1 con DAO ",
            "enunciado" => "Listar las edades de los ciclistas (sin repetidos)",
            "sql" => "SELECT DISTINC edad FROM ciclista",
        ]);
    }
    public function actionConsulta1a(){
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()->select ("edad")->distinct(),
        ]);
         return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['edad'],
            "titulo"=> "Consulta 1 con ActiveDataProvider ",
            "enunciado" => "Listar las edades de los ciclistas (sin repetidos)",
            "sql" => "SELECT DISTINC edad FROM ciclista",
        ]);
    }
    public function actionConsulta2(){
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT edad FROM ciclista WHERE nomequipo = "Artiach"',
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['edad'],
            "titulo"=> "Consulta 2 con DAO ",
            "enunciado" => "Listar las edades de los ciclistas del equipo Artiach",
            "sql" => "SELECT DISTINC edad FROM ciclista WHERE nomequipo = 'Artiach'",
        ]);
    }
    public function actionConsulta2a(){
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()->select ("edad")->distinct()->where('nomequipo="Artiach"') ,
        ]);
         return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['edad'],
            "titulo"=> "Consulta 2 con ActiveDataProvider ",
            "enunciado" => "Listar las edades de los ciclistas del equipo Artiach",
            "sql" => "SELECT DISTINC edad FROM ciclista WHERE nomequipo = 'Artiach'",
        ]);
    }
    
     public function actionConsulta3(){
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT edad FROM ciclista WHERE nomequipo = "Artiach" OR nomequipo = "Amore Vita"',
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['edad'],
            "titulo"=> "Consulta 3 con DAO ",
            "enunciado" => "Listar las edades de los ciclistas del equipo Artiach o de Amore Vita",
            "sql" => "SELECT DISTINC edad FROM ciclista WHERE nomequipo = 'Artiach' OR nomequipo = 'Amore Vita'",
        ]);
    }
    public function actionConsulta3a(){
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()->select ("edad")->distinct()->where('nomequipo="Artiach" OR nomequipo="Amore Vita"') ,
        ]);
         return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['edad'],
            "titulo"=> "Consulta 3 con ActiveDataProvider ",
            "enunciado" => "Listar las edades de los ciclistas del equipo Artiach o de Amore Vita",
            "sql" => "SELECT DISTINC edad FROM ciclista WHERE nomequipo = 'Artiach' OR nomequipo = 'Amore Vita'",
        ]);
    }
    
      public function actionConsulta4(){
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT dorsal FROM ciclista WHERE edad < 25 OR edad >30',
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 4 con DAO ",
            "enunciado" => "Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30",
            "sql" => "SELECT DISTINCT dorsal FROM ciclista WHERE edad < 25 OR edad >30",
        ]);
    }
    public function actionConsulta4a(){
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()->select ("dorsal")->distinct()->where('edad < 25 OR edad >30') ,
        ]);
         return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 4 con ActiveDataProvider ",
            "enunciado" => "Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30",
            "sql" => "SELECT DISTINCT dorsal FROM ciclista WHERE edad < 25 OR edad >30",
        ]);
    }
    
    public function actionConsulta5(){
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT dorsal FROM ciclista WHERE edad > 28 AND edad <32 AND nomequipo = "Banesto"',
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 5 con DAO ",
            "enunciado" => "listar los dorsales de los ciclistas cuya edad esté entre 28 y 32 y además que sólo sean de Banesto",
            "sql" => 'SELECT DISTINCT dorsal FROM ciclista WHERE edad > 28 AND edad <32 AND nomequipo = "Banesto"',
        ]);
    }
    public function actionConsulta5a(){
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()->select ("dorsal")->distinct()->where('edad > 28 AND edad <32 AND nomequipo = "Banesto"') ,
        ]);
         return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 5 con ActiveDataProvider ",
            "enunciado" => "listar los dorsales de los ciclistas cuya edad esté entre 28 y 32 y además que sólo sean de Banesto",
            "sql" => 'SELECT DISTINCT dorsal FROM ciclista WHERE edad > 28 AND edad <32 AND nomequipo = "Banesto"',
        ]);
    }
     public function actionConsulta6(){
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT nombre FROM ciclista WHERE CHAR_LENGTH(nombre)>8',
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['nombre'],
            "titulo"=> "Consulta 6 con DAO ",
            "enunciado" => "Indícame el nombre de los ciclistas que el número de caracteres del nombre sea mayor que 8",
            "sql" => 'SELECT DISTINCT nombre FROM ciclista WHERE CHAR_LENGTH(nombre)>8',
        ]);
    }
    public function actionConsulta6a(){
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()->select ("nombre")->distinct()->where('CHAR_LENGTH(nombre)>8') ,
        ]);
         return $this->render("resultado", [
            "resultados"=>$dataProvider, 
            "campos"=>['nombre'],
            "titulo"=> "Consulta 6 con ActiveDataProvider ",
            "enunciado" => "Indícame el nombre de los ciclistas que el número de caracteres del nombre sea mayor que 8",
            "sql" => 'SELECT DISTINCT nombre FROM ciclista WHERE CHAR_LENGTH(nombre)>8',
        ]);
    }
    public function actionConsulta7(){

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
use yii\helpers\Html;
$this->title = 'Consultas de selección 1';
?>

<div class="site-index">
    
        <div class="jumbotron text-center bg-transparent"
             <hl class="display-4">Consultas de Selección</hl>
        </div>
    
    <div class="body-content">
        
        <div class="row">
            <!-- Boton de la consulta -->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 1 </h3>
                        <p>  listar las edades de los ciclistas (sin repetidos)</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta1a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta1'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 2 </h3>
                        <p> Listar las edades de los ciclistas de Artiach</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta2a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta2'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 3 </h3>
                        <p> listar las edades de los ciclistas de Artiach o de Amore Vita</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta3a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta3'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 4 </h3>
                        <p> Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta4a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta4'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 5 </h3>
                        <p> listar los dorsales de los ciclistas cuya edad esté entre 28 y 32 y además que sólo sean de Banesto</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta5a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta5'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 6 </h3>
                        <p> Indícame el nombre de los ciclistas que el número de caracteres del nombre sea mayor que 8 </p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta6a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta6'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 7 </h3>
                        <p> Indícame el nombre de los ciclistas que el número de caracteres del nombre sea mayor que 8 </p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta7a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta7'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 8 </h3>
                        <p> Listar todos los ciclistas que han ganado el maillot MGE (amarillo) en alguna etapa </p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta8a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta8'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 9 </h3>
                        <p> Listar el nombre de los puertos cuya altura sea mayor de 1500  </p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta9a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta9'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 10 </h3>
                        <p> Listar el dorsal de los ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 o cuya altura esté entre 1800 y 3000 </p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta10a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta10'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3> Consulta 11 </h3>
                        <p> Listar el dorsal de los ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 y cuya altura esté entre 1800 y 3000 </p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta11a'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/consulta11'], ['class' => 'btn btn-warning'])?> 
                          
                        </p>
                        
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n{input}\n{error}",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label mr-lg-3'],
            'inputOptions' => ['class' => 'col-lg-3 form-control'],
            'errorOptions' => ['class' => 'col-lg-7 invalid-feedback'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>

<div class="jumbotron">
    <h2><?=$titulo?></h2>
    
    <p class="lead"><?= $enunciado ?></p>
    <div class="well">
        <?= $sql ?>
    </div>
</div>

<?=GridView::widget([
    'dataProvider' => $resultados,
    'columns'=> $campos
]); ?>